#205 rEFIt 0.14 doesn't work with MAC OS X LION 10.7

open
nobody
7
2011-07-25
2011-07-24
jksd
No

After updating to Lion, rEFIt 0.14 doesn't work. Even manual installation doesn't work.

System comes up without rEFIt OS selection screen. When proceeding Lion boot, system hangs. After that you have to boot from MAC OS system dvd.

Discussion

  • jksd
    jksd
    2011-07-25

    • priority: 5 --> 7
     
  • Kalsta
    Kalsta
    2011-07-30

    Doesn't work on triple boot for me (MacBook Pro 8.2), it picks up the Mac OS 10.7 (Lion), and my Windows 7 and both boot correctly, but it doesn't pick up the Mac Recovery Partition at all (new Lion feature to make up for lack of install disk) and my Ubuntu 11.04 partition shows up in rEFIt but won't boot (goes to 'Missing Operating System' screen), I've tried reinstalling Ubuntu but no joy :-(

     
  • Joe van Tunen
    Joe van Tunen
    2011-08-02

    rEFIt worked for me on my Mac Pro 2008. I can select different OSes and boot Lion.

    Currently rEFIt won't show the Recover HD partition because the .efi file is in a non-standard location.

    You can mount the Recovery HD partition using "diskutil list" to find the Recovery HD partition device then pass it to the mount_hfs command. For example, if "diskutil list" shows:
    5: Apple_Boot Recovery HD 650.0 MB disk2s5

    Then you would do the following to mount it:
    mkdir "/tmp/RecoveryHD"
    mount_hfs /dev/disk2s5 "/tmp/RecoveryHD"

    And the following command to show the contents:
    ls -lRFA /tmp/RecoveryHD
    total 0
    d-wx-wx-wt 3 root wheel 102 Aug 1 21:04 .Trashes/
    drwxr-xr-x 3 root wheel 102 Jul 24 13:24 .fseventsd/
    -rw-r--r-- 1 root wheel 0 Jul 24 13:24 .metadata_never_index
    drwxr-xr-x 10 root wheel 340 Jul 24 13:24 com.apple.recovery.boot/

    /tmp/RecoveryHD/.Trashes:

    /tmp/RecoveryHD/.fseventsd:
    total 0
    -rw-r--r-- 1 root wheel 0 Jul 24 13:24 no_log

    /tmp/RecoveryHD/com.apple.recovery.boot:
    total 930048
    -rw-r--r--@ 1 root wheel 749 Jul 24 13:24 .disk_label
    -rw-r--r--@ 1 root admin 1876 Jun 29 23:55 BaseSystem.chunklist
    -rw-r--r--@ 1 root admin 451307798 Jun 29 23:47 BaseSystem.dmg
    -rw-r--r-- 1 root wheel 2245 Jun 15 18:06 PlatformSupport.plist
    -r--r--r-- 1 root wheel 475 Jun 29 20:42 SystemVersion.plist
    -rw-r--r-- 1 root wheel 858800 Jun 29 23:04 boot.efi
    -rw-r--r-- 1 root wheel 361 Jul 24 13:24 com.apple.Boot.plist
    -rw-r--r-- 1 root wheel 23992189 Jun 29 22:41 kernelcache

    You see that the boot.efi file on the Recovery HD is in a folder called com.apple.recovery.boot which rEFIt doesn't know anything about. This needs to be added to the rEFIt source code (function ScanLoader in main.c). I think a better method would be to make rEFIt able to read a list of locations from the config file so you won't need to change the source code again.

    If Lion and Windows 7 work for you, then there's no reason Ubuntu shouldn't work as well. Note that when the Lion installer added the Recover HD partition, it may have renumbered your partitions and maybe Ubuntu has a problem with that. Check your MBR and GPT partitions, MBR boot code, and your Ubuntu swap partition number.

    The following is a script to dump info about your hard disks, partitions, boot blocks, and NVRAM. Put it in a .sh file and execute it with sudo.

    #!/bin/bash
    #
    # Get Partition Info from all disks
    #
    # Written by joevt
    # Patches marked "rgh" July, 2010, to dump information beyond the
    # four bios partitions
    #
    # Based on johnsock's AHCI Master Boot Record Patch.
    #
    # This script is freely distributable.
    # Use of this script could muck up your computer. The author accepts no
    # responsibility for what might happen when you use it.
    #

    if [ ! "$USER" = "root" ]; then
    echo WARNING: This script must be run as root.
    exit
    fi

    MBRHASHES=\ "Windows_XP=d88d4f2dbc2c662db7d7d60ebf9e3e00 "\ "Windows_Vista=12c9d7ff4914c88a7f9eadf9211b861b "\ "Windows_7=118eb70c44cb69284e5d8aa93096831e "\ "None_all_zeros=4ebc676ce4896613a3a9df6e2a1c77ae "\ ""\ "MSDOS_or_FreeDOS_on_FreeDOS=93dd2ee87a995e36cbab0c2d5c2f041a "\ ""\ "Windows_XP_On_BootCamp2_with_AHCI_patch=c3fb54174bc479899d4ef6e45308dc18 "\ "Windows_XP_On_BootCamp2=cb4dabdd862da0508083b05814e198b8 "\ "Windows_Vista_on_XP_with_AHCI_patch=4979e1b9d70738759280f6962c2ad298 "\ "Windows_7_on_XP=7db43c1425e9ff3077dd62b776a50419 "\ "Windows_7_with_AHCI_patch=a243d3475531b0f6f0d7199043c2eb5c "\ "Windows_7_on_XP_with_AHCI_patch=24977c27865adec9ac8298f1a8d214bf "\ ""\ "Apple_Partition_Map_Block0_Driver_Descriptor_Map_390721968_blocks_and_Tiger_OS_9_drivers=087f35e49a39d52a46e3a94882869f51 "\ ""

    #All VBR hashes use all the bytes starting from offset 0x60. It may be better to use a different range for each type of VBR...

    # GRUB2 hash was incorrectly named GRUB #rgh
    # added GRUB hash from observation of kununtu 9.04 #rgh
    VBRHASHES=\ "None_all_zeros=acf496fff71230daa6985a701f83ce49 "\ "NTFS_Windows_XP_NTLDR=dd1728a59343b9fa9458d80657f68771 "\ "NTFS_Windows_Vista_BOOTMGR=d1c278b56eeea9536d0eb5898fe6a0b5 "\ "GRUB_from_Ubuntu=332469fa146db809f58d6392e2e0bdce "\ "GRUB2_from_Ubuntu=9c249066e1eb9c842d8acdfe6d23a2e3 "\ "FAT32_FRDOS4.1=98050815221ee147066f99f806c23203 "\ "FAT32_FRDOS4.1_or_MSWIN4.1_BOOTMGR=aec608de8ac709d91e6f3340b643ab4d "\ "FAT12_BSD_4.4_BOOTMGR=4cc92970d5a3350bc72d2b975e28b915 "\ "FAT16_Non_system_disk=2a3d0f51ad246f115aa7d37891788857 "\ "FAT32_Non_system_disk_or_EFI=34f2d1f3c3ecce5c00cae8f0b82c922b "\ "HFS_boot_block_0=28f5bc1563fbaedeb8dabbd4ef9eb4c2 "\ ""

    FindHash () {
    # $1: name of hashed contents
    # $2: list of known hashes
    # $3: the hash to search for
    DIDFIND=0
    for CURHASH in $2; do
    THEHASH=`expr "$CURHASH" : '[^=]*=\(.*\)'`
    THEOS=`expr "$CURHASH" : '^\([^=]*\)='`
    if [ "$3" = "$THEHASH" ]; then
    DIDFIND=1
    break
    fi
    done
    echo ""
    if [ $DIDFIND = 1 ]; then
    echo "$1: $THEOS"
    else
    echo "$1: Unrecognized (hash=$3)"
    fi
    }

    DRIVELIST=`diskutil list | sed -n -E "/^[ ]*0: [ ]{0,25}([A-Za-z_]+)[ ]*\*[0-9.]+ [TGMK]B[ ]+(disk[0-9]+)$/s//\1_\2/p;/^[ ]*0: [ ]{0,26} .* \*[0-9.]+ [TGMK]B[ ]+(disk[0-9]+)$/s//whole_\1/p"`
    for PARTDRIVE in $DRIVELIST;
    do
    DRIVE=`expr "$PARTDRIVE" : '.*_\([^_]*\)'`
    PTYPE=`expr "$PARTDRIVE" : '\(.*\)_[^_]*'`
    echo "==============================================================================="

    diskutiloutput="`diskutil list \"/dev/$DRIVE\"`"
    echo "$diskutiloutput"

    DEVLIST=`echo "$diskutiloutput" | sed -n -E "/^.* (disk[0-9]+(s[0-9]+)*)$/s//\1/p"`
    for THEDEV in $DEVLIST; do
    echo "---------------------------------------------"
    diskutil info $THEDEV
    done

    if [ "$PTYPE" = "Apple_partition_scheme" ]; then
    pdisk -r -l "/dev/$DRIVE"
    pdisk -r -l -f "/dev/$DRIVE"

    # use the same bytes as MBR hash even though Block0 contents are totally different
    HASH=`dd if="/dev/$DRIVE" bs=1 count=446 2> /dev/null | xxd -p -l 440 | md5`
    FindHash "Block0 contents" "$MBRHASHES" "$HASH"
    dd if="/dev/$DRIVE" bs=1 count=512 2> /dev/null | xxd -c 16
    elif [ "$PTYPE" = "GUID_partition_scheme" -o "$PTYPE" = "FDisk_partition_scheme" ]; then

    gptoutput="`gpt -r show \"$DRIVE\" 2>&1`"
    gptoutput2="`gpt -r show -l \"$DRIVE\" 2>&1`"
    fdiskoutput="`fdisk \"/dev/r$DRIVE\"`"

    echo "$gptoutput"
    echo "$gptoutput2"
    echo "$fdiskoutput"

    HASH=`dd if="/dev/$DRIVE" bs=1 count=446 2> /dev/null | xxd -p -l 440 | md5`
    FindHash "MBR contents" "$MBRHASHES" "$HASH"
    dd if="/dev/$DRIVE" bs=1 count=512 2> /dev/null | xxd -c 16

    if [ "$PTYPE" = "FDisk_partition_scheme" ]; then
    PARTLIST=`echo "$fdiskoutput" | sed -n -E "/^[ \*]+([0-9])\: .*\[[ ]*([0-9]+) \-[ ]+([1-9][0-9]*)\].*$/s//\1_\2_\3/p"`
    PARTTYPE="MBR"
    else
    PARTLIST=`echo "$gptoutput" | sed -n -E "/^[ ]+([0-9]+)[ ]+([0-9]+)[ ]+([0-9]+)[ ]+GPT part \-.*$/s//\3_\1_\2/p"`
    PARTTYPE="GPT"
    fi

    for THEPART in $PARTLIST; do
    PNUM=`expr "$THEPART" : '\([0-9]*\)_'`
    PSTART=`expr "$THEPART" : '[0-9]*_\([0-9]*\)_[0-9]*'`
    PLENGTH=`expr "$THEPART" : '[0-9]*_[0-9]*_\([0-9]*\)'`

    HASH=`dd if="/dev/$DRIVE" bs=1 skip=\`expr "$PSTART" "*" 512 "+" 96\` count=416 2> /dev/null | xxd -p -l 440 | md5`
    FindHash "$PARTTYPE $PNUM @ $PSTART: VBR contents" "$VBRHASHES" "$HASH"
    dd if="/dev/$DRIVE" bs=512 skip=$PSTART count=1 2> /dev/null | xxd -c 16
    done
    elif [ "$PTYPE" = "whole" ]; then
    HASH=`dd if="/dev/$DRIVE" bs=1 count=416 2> /dev/null | xxd -p -l 440 | md5`
    FindHash "0 @ 0: VBR contents" "$VBRHASHES" "$HASH"
    dd if="/dev/$DRIVE" bs=512 count=1 2> /dev/null | xxd -c 16
    else
    echo "Unknown partition scheme"
    fi
    done
    echo "==============================================================================="
    bless --verbose --getboot
    echo "==============================================================================="
    bless --verbose --info
    echo "==============================================================================="
    ioreg -S -w 0 -c IOMedia | sed -n -E "/^[ \|]+ \+\-o (.*) <class IOMedia>$/,/^[ \|]+ }$/p" | sed -n -E "/^[ \|]+ \+\-o (.*)/s//\1/p;/^[ \|]+ \| (.*)/s//\1/p;"
    echo "==============================================================================="
    ioreg -w 0 -n AppleEFINVRAM | sed -n -E "/^[ \|]+[ ]+(\".*)$/s//\1/p;"
    echo "==============================================================================="

     
  • Kalsta
    Kalsta
    2011-08-02

    Hi Joe,

    Thanks for getting back to me, I ran your script and got this result:

    drives.sh: line 43: better: command not found
    sed: 1: "/^[ ]*0: [ ]{0,25}([A-Z ...": unbalanced brackets ([])

    drives.sh: line 159: ===============================================================================: command not found
    EFI found at IODeviceTree:/efi
    Current EFI boot device string is: '<array><dict><key>IOMatch</key><dict><key>IOProviderClass</key><string>IOMedia</string><key>IOPropertyMatch</key><dict><key>UUID</key><string>462B8094-8A52-4B95-B1DC-7200F0D1B783</string></dict></dict><key>BLLastBSDName</key><string>disk0s2</string></dict></array>'
    Boot option is 8BE4DF61-93CA-11D2-AA0D-00E098032B8C:Boot0080
    Processing boot option 'Mac OS X'
    Boot option matches XML representation
    Found device: disk0s2
    Disk boot device detected
    /dev/disk0s2

    drives.sh: line 162: ===============================================================================: command not found
    EFI found at IODeviceTree:/efi
    Current EFI boot device string is: '<array><dict><key>IOMatch</key><dict><key>IOProviderClass</key><string>IOMedia</string><key>IOPropertyMatch</key><dict><key>UUID</key><string>462B8094-8A52-4B95-B1DC-7200F0D1B783</string></dict></dict><key>BLLastBSDName</key><string>disk0s2</string></dict></array>'
    Boot option is 8BE4DF61-93CA-11D2-AA0D-00E098032B8C:Boot0080
    Processing boot option 'Mac OS X'
    Boot option matches XML representation
    Found device: disk0s2
    Disk boot device detected
    mount: /
    Mount point for / is /
    Boot blocks read successfully
    GPT detected
    No auxiliary booter partition required
    System partition found
    Returning booter information dictionary:
    <CFBasicHash 0x7ff434b00410 [0x7fff776d9ea0]>{type = mutable dict, count = 3,
    entries =>
    0 : <CFString 0x1061fffb0 [0x7fff776d9ea0]>{contents = "System Partitions"} = (
    disk0s1
    )
    1 : <CFString 0x1061fff70 [0x7fff776d9ea0]>{contents = "Data Partitions"} = (
    disk0s2
    )
    2 : <CFString 0x1061fff50 [0x7fff776d9ea0]>{contents = "Auxiliary Partitions"} = (
    )
    }

    finderinfo[0]: 116 => Blessed System Folder is /System/Library/CoreServices
    finderinfo[1]: 280701 => Blessed System File is /System/Library/CoreServices/boot.efi
    finderinfo[2]: 0 => Open-folder linked list empty
    finderinfo[3]: 0 => No alternate OS blessed file/folder
    finderinfo[4]: 0 => Unused field unset
    finderinfo[5]: 116 => OS X blessed folder is /System/Library/CoreServices
    64-bit VSDB volume id: 0x6BC2248DCDBBBD1F

    drives.sh: line 165: ===============================================================================: command not found
    sed: 1: "/^[ \|]+ \+\-o (.*) <cl ...": unterminated regular expression
    sed: 1: "/^[ \|]+ \+\-o (.*)/s// ...": unterminated regular expression

    drives.sh: line 170: ===============================================================================: command not found
    "fmm-computer-name" = <"Kal Jade’s MacBook Pro">
    "boot-image" = <02010c00d041030a0000000001010600021f03120a000000000000000404180032003800300064003000320030003000300000007fff0400>
    "SystemAudioVolume" = <5b>
    "gpu-policy" = <01>
    "BootCampHD" = <02010c00d041030a0000000001010600021f03120a000000000000007fff0400>
    "efi-apple-payload1" = <"<array><dict><key>IOMatch</key><dict><key>IOProviderClass</key><string>IOMedia</string><key>IOPropertyMatch</key><dict><key>UUID</key><string>3E7D4DE4-59C2-461E-9C86-802926A11C58</string></dict></dict><key>BLLastBSDName</key><string>disk0s1</string></dict><dict><key>IOEFIDevicePathType</key><string>MediaFilePath</string><key>Path</key><string>\EFI\APPLE\FIRMWARE\HPM-em-00020007.bin</string></dict></array>">
    "prev-lang:kbd" = <"English:15">
    "EFICapsule_Result" = <"STAR">
    "efi-apple-recovery" = <"<array><dict><key>IOMatch</key><dict><key>IOProviderClass</key><string>IOMedia</string><key>IOPropertyMatch</key><dict><key>UUID</key><string>3E7D4DE4-59C2-461E-9C86-802926A11C58</string></dict></dict><key>BLLastBSDName</key><string>disk0s1</string></dict><dict><key>IOEFIDevicePathType</key><string>MediaFilePath</string><key>Path</key><string>\EFI\APPLE\FIRMWARE\MBP81_0047_0EB_LOCKED.scap</string></dict></array>">
    "efi-apple-payload0-data" = <02010c00d041030a0000000001010600021f03120a0000000000000004012a000100000028000000000000000040060000000000e44d7d3ec2591e469c86802926a11c580202040448005c004500460049005c004100500050004c0045005c004600490052004d0057004100520045005c004d00420050002d00320032002d00300031002e00620069006e0000007fff0400>
    "ThorUpdateResult" = <000005020003000000000000000000000000000000000000>
    "tbt-options" = <00>
    "aht-results" = <"<dict><key>_name</key><string>spdiags_aht_value</string><key>spdiags_last_run_key</key><date>4011-07-10T07:02:47Z</date><key>spdiags_result_key</key><string>spdiags_passed_value</string><key>spdiags_version_key</key><string>3A209</string></dict>">
    "efi-apple-payload0" = <"<array><dict><key>IOMatch</key><dict><key>IOProviderClass</key><string>IOMedia</string><key>IOPropertyMatch</key><dict><key>UUID</key><string>3E7D4DE4-59C2-461E-9C86-802926A11C58</string></dict></dict><key>BLLastBSDName</key><string>disk0s1</string></dict><dict><key>IOEFIDevicePathType</key><string>MediaFilePath</string><key>Path</key><string>\EFI\APPLE\FIRMWARE\MBP-22-01.bin</string></dict></array>">
    "efi-boot-device-data" = <02010c00d041030a0000000001010600021f03120a0000000000000004012a00020000002840060000000000b0c87d070000000094802b46528a954bb1dc7200f0d1b78302027fff0400>
    "efi-boot-device" = "<array><dict><key>IOMatch</key><dict><key>IOProviderClass</key><string>IOMedia</string><key>IOPropertyMatch</key><dict><key>UUID</key><string>462B8094-8A52-4B95-B1DC-7200F0D1B783</string></dict></dict><key>BLLastBSDName</key><string>disk0s2</string></dict></array>"
    "efi-apple-payload1-data" = <02010c00d041030a0000000001010600021f03120a0000000000000004012a000100000028000000000000000040060000000000e44d7d3ec2591e469c86802926a11c580202040454005c004500460049005c004100500050004c0045005c004600490052004d0057004100520045005c00480050004d002d0065006d002d00300030003000320030003000300037002e00620069006e0000007fff0400>

    drives.sh: line 173: ===============================================================================: command not found
    CHEETA-Mac:desktop kal$ sudo sh drives.sh
    drives.sh: line 43: better: command not found
    sed: 1: "/^[ ]*0: [ ]{0,25}([A-Z ...": unbalanced brackets ([])

    drives.sh: line 159: ===============================================================================: command not found
    EFI found at IODeviceTree:/efi
    Current EFI boot device string is: '<array><dict><key>IOMatch</key><dict><key>IOProviderClass</key><string>IOMedia</string><key>IOPropertyMatch</key><dict><key>UUID</key><string>462B8094-8A52-4B95-B1DC-7200F0D1B783</string></dict></dict><key>BLLastBSDName</key><string>disk0s2</string></dict></array>'
    Boot option is 8BE4DF61-93CA-11D2-AA0D-00E098032B8C:Boot0080
    Processing boot option 'Mac OS X'
    Boot option matches XML representation
    Found device: disk0s2
    Disk boot device detected
    /dev/disk0s2

    drives.sh: line 162: ===============================================================================: command not found
    EFI found at IODeviceTree:/efi
    Current EFI boot device string is: '<array><dict><key>IOMatch</key><dict><key>IOProviderClass</key><string>IOMedia</string><key>IOPropertyMatch</key><dict><key>UUID</key><string>462B8094-8A52-4B95-B1DC-7200F0D1B783</string></dict></dict><key>BLLastBSDName</key><string>disk0s2</string></dict></array>'
    Boot option is 8BE4DF61-93CA-11D2-AA0D-00E098032B8C:Boot0080
    Processing boot option 'Mac OS X'
    Boot option matches XML representation
    Found device: disk0s2
    Disk boot device detected
    mount: /
    Mount point for / is /
    Boot blocks read successfully
    GPT detected
    No auxiliary booter partition required
    System partition found
    Returning booter information dictionary:
    <CFBasicHash 0x7fcc48d02590 [0x7fff776d9ea0]>{type = mutable dict, count = 3,
    entries =>
    0 : <CFString 0x10cca5fb0 [0x7fff776d9ea0]>{contents = "System Partitions"} = (
    disk0s1
    )
    1 : <CFString 0x10cca5f70 [0x7fff776d9ea0]>{contents = "Data Partitions"} = (
    disk0s2
    )
    2 : <CFString 0x10cca5f50 [0x7fff776d9ea0]>{contents = "Auxiliary Partitions"} = (
    )
    }

    finderinfo[0]: 116 => Blessed System Folder is /System/Library/CoreServices
    finderinfo[1]: 280701 => Blessed System File is /System/Library/CoreServices/boot.efi
    finderinfo[2]: 0 => Open-folder linked list empty
    finderinfo[3]: 0 => No alternate OS blessed file/folder
    finderinfo[4]: 0 => Unused field unset
    finderinfo[5]: 116 => OS X blessed folder is /System/Library/CoreServices
    64-bit VSDB volume id: 0x6BC2248DCDBBBD1F

    drives.sh: line 165: ===============================================================================: command not found
    sed: 1: "/^[ \|]+ \+\-o (.*) <cl ...": unterminated regular expression
    sed: 1: "/^[ \|]+ \+\-o (.*)/s// ...": unterminated regular expression

    drives.sh: line 170: ===============================================================================: command not found
    "fmm-computer-name" = <"Kal Jade’s MacBook Pro">
    "boot-image" = <02010c00d041030a0000000001010600021f03120a000000000000000404180032003800300064003000320030003000300000007fff0400>
    "SystemAudioVolume" = <5b>
    "gpu-policy" = <01>
    "BootCampHD" = <02010c00d041030a0000000001010600021f03120a000000000000007fff0400>
    "efi-apple-payload1" = <"<array><dict><key>IOMatch</key><dict><key>IOProviderClass</key><string>IOMedia</string><key>IOPropertyMatch</key><dict><key>UUID</key><string>3E7D4DE4-59C2-461E-9C86-802926A11C58</string></dict></dict><key>BLLastBSDName</key><string>disk0s1</string></dict><dict><key>IOEFIDevicePathType</key><string>MediaFilePath</string><key>Path</key><string>\EFI\APPLE\FIRMWARE\HPM-em-00020007.bin</string></dict></array>">
    "prev-lang:kbd" = <"English:15">
    "EFICapsule_Result" = <"STAR">
    "efi-apple-recovery" = <"<array><dict><key>IOMatch</key><dict><key>IOProviderClass</key><string>IOMedia</string><key>IOPropertyMatch</key><dict><key>UUID</key><string>3E7D4DE4-59C2-461E-9C86-802926A11C58</string></dict></dict><key>BLLastBSDName</key><string>disk0s1</string></dict><dict><key>IOEFIDevicePathType</key><string>MediaFilePath</string><key>Path</key><string>\EFI\APPLE\FIRMWARE\MBP81_0047_0EB_LOCKED.scap</string></dict></array>">
    "efi-apple-payload0-data" = <02010c00d041030a0000000001010600021f03120a0000000000000004012a000100000028000000000000000040060000000000e44d7d3ec2591e469c86802926a11c580202040448005c004500460049005c004100500050004c0045005c004600490052004d0057004100520045005c004d00420050002d00320032002d00300031002e00620069006e0000007fff0400>
    "ThorUpdateResult" = <000005020003000000000000000000000000000000000000>
    "tbt-options" = <00>
    "aht-results" = <"<dict><key>_name</key><string>spdiags_aht_value</string><key>spdiags_last_run_key</key><date>4011-07-10T07:02:47Z</date><key>spdiags_result_key</key><string>spdiags_passed_value</string><key>spdiags_version_key</key><string>3A209</string></dict>">
    "efi-apple-payload0" = <"<array><dict><key>IOMatch</key><dict><key>IOProviderClass</key><string>IOMedia</string><key>IOPropertyMatch</key><dict><key>UUID</key><string>3E7D4DE4-59C2-461E-9C86-802926A11C58</string></dict></dict><key>BLLastBSDName</key><string>disk0s1</string></dict><dict><key>IOEFIDevicePathType</key><string>MediaFilePath</string><key>Path</key><string>\EFI\APPLE\FIRMWARE\MBP-22-01.bin</string></dict></array>">
    "efi-boot-device-data" = <02010c00d041030a0000000001010600021f03120a0000000000000004012a00020000002840060000000000b0c87d070000000094802b46528a954bb1dc7200f0d1b78302027fff0400>
    "efi-boot-device" = "<array><dict><key>IOMatch</key><dict><key>IOProviderClass</key><string>IOMedia</string><key>IOPropertyMatch</key><dict><key>UUID</key><string>462B8094-8A52-4B95-B1DC-7200F0D1B783</string></dict></dict><key>BLLastBSDName</key><string>disk0s2</string></dict></array>"
    "efi-apple-payload1-data" = <02010c00d041030a0000000001010600021f03120a0000000000000004012a000100000028000000000000000040060000000000e44d7d3ec2591e469c86802926a11c580202040454005c004500460049005c004100500050004c0045005c004600490052004d0057004100520045005c00480050004d002d0065006d002d00300030003000320030003000300037002e00620069006e0000007fff0400>

    drives.sh: line 173: ===============================================================================: command not found

    I still don't know how to add the Recovery HD to rEFIt or get my Linux partition to boot. I ran diskutil list and got this info:

    diskutil list
    /dev/disk0
    #: TYPE NAME SIZE IDENTIFIER
    0: GUID_partition_scheme *500.1 GB disk0
    1: EFI 209.7 MB disk0s1
    2: Apple_HFS Mac OS X 64.4 GB disk0s2
    3: Apple_Boot Recovery HD 650.0 MB disk0s3
    4: Microsoft Basic Data Windows 7 400.5 GB disk0s4
    5: Microsoft Basic Data 33.3 GB disk0s5
    6: Linux Swap 1.1 GB disk0s6

    But I am still no closer to getting it to work on rEFIt. I know my Linux partition is working as I can boot it up from the Windows EasyBCD boot loader, but a two-step boot process is less than ideal.

    If the recovery drive has renumbered my partitions how do I fix that in rEFIt I don't see any settings like that in the config file?

    Thanks again for all your assistance,

    Regards,

    Kal

     
  • Joe van Tunen
    Joe van Tunen
    2011-08-02

    The script didn't work because the sourceforge comment didn't preserve the spacing and line lengths. You can download the script here:
    http://members.shaw.ca/joevt/dumpvols.sh.zip

    What settings is EasyBCD using for your Linux?

    I think you're using a boot loader on the Windows partition to boot the Linux partition. rEFIt works by setting the boot partition in the MBR before calling BIOS. This means that your Linux partition needs it's own boot code in its own boot block (the first block of the partition). After you boot into Linux using EasyBCD, set the boot partition in the MBR to the Linux partition using fdisk or whatever, and reinstall GRUB (make sure GRUB is not installed to the MBR - it should be installed on the Linux partition only). You could also create a Linux Boot Partition and install GRUB to that. In that case, the Linux Boot Partition would need to be listed in the MBR so that rEFIt will use BIOS to boot it. GRUB in the Linux Boot Partition does not require the Linux partition to be listed in the MBR because GRUB will be able to find it in the GPT.

    To make the Recovery HD partition work with rEFIt you need to either change rEFIt (source code is available - I think you can compile it on Windows using free Microsoft development tools) or you need to change the Recovery HD so that the boot.efi file is in a place where rEFIt can find it (maybe by renaming com.apple.recovery.boot to EFI, or moving boot.efi to the root directory).

     
  • Kalsta
    Kalsta
    2011-08-02

    Hi Joe,

    I downloaded the script and this is the result:

    CHEETA-Mac:desktop kal$ sudo sh dumpvols.sh
    Password:
    ===============================================================================
    /dev/disk0
    #: TYPE NAME SIZE IDENTIFIER
    0: GUID_partition_scheme *500.1 GB disk0
    1: EFI 209.7 MB disk0s1
    2: Apple_HFS Mac OS X 64.4 GB disk0s2
    3: Apple_Boot Recovery HD 650.0 MB disk0s3
    4: Microsoft Basic Data Windows 7 400.5 GB disk0s4
    5: Microsoft Basic Data 33.3 GB disk0s5
    6: Linux Swap 1.1 GB disk0s6
    ---------------------------------------------
    Device Identifier: disk0
    Device Node: /dev/disk0
    Part of Whole: disk0
    Device / Media Name: Hitachi HTS725050A9A362 Media

    Volume Name: Not applicable (no file system)

    Mounted: Not applicable (no file system)

    File System: None

    Content (IOContent): GUID_partition_scheme
    OS Can Be Installed: No
    Media Type: Generic
    Protocol: SATA
    SMART Status: Verified

    Total Size: 500.1 GB (500107862016 Bytes) (exactly 976773168 512-Byte-Blocks)
    Volume Free Space: Not applicable (no file system)
    Device Block Size: 512 Bytes

    Read-Only Media: No
    Read-Only Volume: Not applicable (no file system)
    Ejectable: No

    Whole: Yes
    Internal: Yes
    Solid State: No
    OS 9 Drivers: No
    Low Level Format: Not supported

    ---------------------------------------------
    Device Identifier: disk0s1
    Device Node: /dev/disk0s1
    Part of Whole: disk0
    Device / Media Name: EFI System Partition

    Volume Name: Not applicable (no file system)

    Mounted: Not applicable (no file system)

    File System: None

    Partition Type: EFI
    OS Can Be Installed: No
    Media Type: Generic
    Protocol: SATA
    SMART Status: Verified

    Total Size: 209.7 MB (209715200 Bytes) (exactly 409600 512-Byte-Blocks)
    Volume Free Space: Not applicable (no file system)
    Device Block Size: 512 Bytes

    Read-Only Media: No
    Read-Only Volume: Not applicable (no file system)
    Ejectable: No

    Whole: No
    Internal: Yes
    Solid State: No

    ---------------------------------------------
    Device Identifier: disk0s2
    Device Node: /dev/disk0s2
    Part of Whole: disk0
    Device / Media Name: Mac OS X

    Volume Name: Mac OS X
    Escaped with Unicode: Mac%FF%FE%20%00OS%FF%FE%20%00X

    Mounted: Yes
    Mount Point: /
    Escaped with Unicode: /

    File System Personality: Journaled HFS+
    Type (Bundle): hfs
    Name (User Visible): Mac OS Extended (Journaled)
    Journal: Journal size 8192 KB at offset 0x1e6000
    Owners: Enabled

    Partition Type: Apple_HFS
    OS Can Be Installed: Yes
    Media Type: Generic
    Protocol: SATA
    SMART Status: Verified
    Volume UUID: AFA80E34-1CC3-3802-9A2F-19FA434020F0

    Total Size: 64.4 GB (64350150656 Bytes) (exactly 125683888 512-Byte-Blocks)
    Volume Free Space: 27.2 GB (27196960768 Bytes) (exactly 53119064 512-Byte-Blocks)
    Device Block Size: 512 Bytes

    Read-Only Media: No
    Read-Only Volume: No
    Ejectable: No

    Whole: No
    Internal: Yes
    Solid State: No

    ---------------------------------------------
    Device Identifier: disk0s3
    Device Node: /dev/disk0s3
    Part of Whole: disk0
    Device / Media Name: Recovery HD

    Volume Name: Recovery HD
    Escaped with Unicode: Recovery%FF%FE%20%00HD

    Mounted: No

    File System Personality: Journaled HFS+
    Type (Bundle): hfs
    Name (User Visible): Mac OS Extended (Journaled)
    Journal: Unknown (not mounted)
    Owners: Disabled

    Partition Type: Apple_Boot
    OS Can Be Installed: No
    Media Type: Generic
    Protocol: SATA
    SMART Status: Verified
    Volume UUID: 686DAD46-42B1-33EE-8C31-5498BF26A752

    Total Size: 650.0 MB (650006528 Bytes) (exactly 1269544 512-Byte-Blocks)
    Volume Free Space: 0 B (0 Bytes) (exactly 0 512-Byte-Blocks)
    Device Block Size: 512 Bytes

    Read-Only Media: No
    Read-Only Volume: Not applicable (not mounted)
    Ejectable: No

    Whole: No
    Internal: Yes
    Solid State: No

    ---------------------------------------------
    Device Identifier: disk0s4
    Device Node: /dev/disk0s4
    Part of Whole: disk0
    Device / Media Name: BOOTCAMP

    Volume Name: Windows 7
    Escaped with Unicode: Windows%FF%FE%20%007

    Mounted: Yes
    Mount Point: /Volumes/Windows 7
    Escaped with Unicode: /Volumes/Windows%FF%FE%20%007

    File System Personality: UFSD_NTFS_COMPR
    Type (Bundle): ufsd_NTFS
    Name (User Visible): Windows NT Filesystem (compressed)

    Partition Type: Microsoft Basic Data
    OS Can Be Installed: No
    Media Type: Generic
    Protocol: SATA
    SMART Status: Verified
    Volume UUID: ADB9FB68-4C12-42BC-8533-CC0741C26772

    Total Size: 400.5 GB (400519331840 Bytes) (exactly 782264320 512-Byte-Blocks)
    Volume Free Space: 23.4 GB (23381225472 Bytes) (exactly 45666456 512-Byte-Blocks)
    Device Block Size: 512 Bytes

    Read-Only Media: No
    Read-Only Volume: No
    Ejectable: No

    Whole: No
    Internal: Yes
    Solid State: No

    ---------------------------------------------
    Device Identifier: disk0s5
    Device Node: /dev/disk0s5
    Part of Whole: disk0
    Device / Media Name: Untitled 5

    Volume Name:
    Escaped with Unicode:

    Mounted: No

    File System Personality: MS-DOS
    Type (Bundle): msdos
    Name (User Visible): MS-DOS (FAT)

    Partition Type: Microsoft Basic Data
    OS Can Be Installed: No
    Media Type: Generic
    Protocol: SATA
    SMART Status: Verified

    Total Size: 33.3 GB (33304870912 Bytes) (exactly 65048576 512-Byte-Blocks)
    Volume Free Space: 0 B (0 Bytes) (exactly 0 512-Byte-Blocks)
    Device Block Size: 512 Bytes

    Read-Only Media: No
    Read-Only Volume: Not applicable (not mounted)
    Ejectable: No

    Whole: No
    Internal: Yes
    Solid State: No

    ---------------------------------------------
    Device Identifier: disk0s6
    Device Node: /dev/disk0s6
    Part of Whole: disk0
    Device / Media Name: Untitled 6

    Volume Name:
    Escaped with Unicode:

    Mounted: No

    File System Personality: Linux Swap
    Type (Bundle): Linux Swap
    Name (User Visible): Linux Swap

    Partition Type: Linux Swap
    OS Can Be Installed: No
    Media Type: Generic
    Protocol: SATA
    SMART Status: Verified

    Total Size: 1.1 GB (1073741824 Bytes) (exactly 2097152 512-Byte-Blocks)
    Volume Free Space: 0 B (0 Bytes) (exactly 0 512-Byte-Blocks)
    Device Block Size: 512 Bytes

    Read-Only Media: No
    Read-Only Volume: Not applicable (not mounted)
    Ejectable: No

    Whole: No
    Internal: Yes
    Solid State: No

    gpt show: disk0: Suspicious MBR at sector 0
    start size index contents
    0 1 MBR
    1 1 Pri GPT header
    2 32 Pri GPT table
    34 6
    40 409600 1 GPT part - C12A7328-F81F-11D2-BA4B-00A0C93EC93B
    409640 125683888 2 GPT part - 48465300-0000-11AA-AA11-00306543ECAC
    126093528 1269544 3 GPT part - 426F6F74-0000-11AA-AA11-00306543ECAC
    127363072 782264320 4 GPT part - EBD0A0A2-B9E5-4433-87C0-68B6B72699C7
    909627392 65048576 5 GPT part - EBD0A0A2-B9E5-4433-87C0-68B6B72699C7
    974675968 2097152 6 GPT part - 0657FD6D-A4AB-43C4-84E5-0933C84B4F4F
    976773120 15
    976773135 32 Sec GPT table
    976773167 1 Sec GPT header
    gpt show: disk0: Suspicious MBR at sector 0
    start size index contents
    0 1 MBR
    1 1 Pri GPT header
    2 32 Pri GPT table
    34 6
    40 409600 1 GPT part - "EFI System Partition"
    409640 125683888 2 GPT part - "Mac OS X"
    126093528 1269544 3 GPT part - "Recovery HD"
    127363072 782264320 4 GPT part - "BOOTCAMP"
    909627392 65048576 5 GPT part - ""
    974675968 2097152 6 GPT part - ""
    976773120 15
    976773135 32 Sec GPT table
    976773167 1 Sec GPT header
    Disk: /dev/rdisk0 geometry: 60801/255/63 [976773168 sectors]
    Signature: 0xAA55
    Starting Ending
    #: id cyl hd sec - cyl hd sec [ start - size]
    ------------------------------------------------------------------------
    1: EE 1023 254 63 - 1023 254 63 [ 1 - 409639] <Unknown ID>
    2: AF 1023 254 63 - 1023 254 63 [ 409640 - 125683888] HFS+
    3: AB 1023 254 63 - 1023 254 63 [ 126093528 - 1269544] Darwin Boot
    *4: 07 1023 254 63 - 1023 254 63 [ 127363072 - 782264320] HPFS/QNX/AUX

    MBR contents: Windows_7
    0000000: 33c0 8ed0 bc00 7c8e c08e d8be 007c bf00 3.....|......|..
    0000010: 06b9 0002 fcf3 a450 681c 06cb fbb9 0400 .......Ph.......
    0000020: bdbe 0780 7e00 007c 0b0f 850e 0183 c510 ....~..|........
    0000030: e2f1 cd18 8856 0055 c646 1105 c646 1000 .....V.U.F...F..
    0000040: b441 bbaa 55cd 135d 720f 81fb 55aa 7509 .A..U..]r...U.u.
    0000050: f7c1 0100 7403 fe46 1066 6080 7e10 0074 ....t..F.f`.~..t
    0000060: 2666 6800 0000 0066 ff76 0868 0000 6800 &fh....f.v.h..h.
    0000070: 7c68 0100 6810 00b4 428a 5600 8bf4 cd13 |h..h...B.V.....
    0000080: 9f83 c410 9eeb 14b8 0102 bb00 7c8a 5600 ............|.V.
    0000090: 8a76 018a 4e02 8a6e 03cd 1366 6173 1cfe .v..N..n...fas..
    00000a0: 4e11 750c 807e 0080 0f84 8a00 b280 eb84 N.u..~..........
    00000b0: 5532 e48a 5600 cd13 5deb 9e81 3efe 7d55 U2..V...]...>.}U
    00000c0: aa75 6eff 7600 e88d 0075 17fa b0d1 e664 .un.v....u.....d
    00000d0: e883 00b0 dfe6 60e8 7c00 b0ff e664 e875 ......`.|....d.u
    00000e0: 00fb b800 bbcd 1a66 23c0 753b 6681 fb54 .......f#.u;f..T
    00000f0: 4350 4175 3281 f902 0172 2c66 6807 bb00 CPAu2....r,fh...
    0000100: 0066 6800 0200 0066 6808 0000 0066 5366 .fh....fh....fSf
    0000110: 5366 5566 6800 0000 0066 6800 7c00 0066 SfUfh....fh.|..f
    0000120: 6168 0000 07cd 1a5a 32f6 ea00 7c00 00cd ah.....Z2...|...
    0000130: 18a0 b707 eb08 a0b6 07eb 03a0 b507 32e4 ..............2.
    0000140: 0500 078b f0ac 3c00 7409 bb07 00b4 0ecd ......<.t.......
    0000150: 10eb f2f4 ebfd 2bc9 e464 eb00 2402 e0f8 ......+..d..$...
    0000160: 2402 c349 6e76 616c 6964 2070 6172 7469 $..Invalid parti
    0000170: 7469 6f6e 2074 6162 6c65 0045 7272 6f72 tion table.Error
    0000180: 206c 6f61 6469 6e67 206f 7065 7261 7469 loading operati
    0000190: 6e67 2073 7973 7465 6d00 4d69 7373 696e ng system.Missin
    00001a0: 6720 6f70 6572 6174 696e 6720 7379 7374 g operating syst
    00001b0: 656d 0000 0063 7b9a 6832 bb07 0000 00fe em...c{.h2......
    00001c0: ffff eefe ffff 0100 0000 2740 0600 00fe ..........'@....
    00001d0: ffff affe ffff 2840 0600 b0c8 7d07 00fe ......(@....}...
    00001e0: ffff abfe ffff d808 8407 285f 1300 80fe ..........(_....
    00001f0: ffff 07fe ffff 0068 9707 0068 a02e 55aa .......h...h..U.

    GPT 1 @ 40: VBR contents: FAT32_Non_system_disk_or_EFI
    0000000: eb58 9042 5344 2020 342e 3400 0201 2000 .X.BSD 4.4... .
    0000010: 0200 0000 00f0 0000 2000 1000 0000 0000 ........ .......
    0000020: 0040 0600 4f0c 0000 0000 0000 0200 0000 .@..O...........
    0000030: 0100 0600 0000 0000 0000 0000 0000 0000 ................
    0000040: 0000 2901 17d6 7045 4649 2020 2020 2020 ..)...pEFI
    0000050: 2020 4641 5433 3220 2020 fa31 c08e d0bc FAT32 .1....
    0000060: 007c fb8e d8e8 0000 5e83 c619 bb07 00fc .|......^.......
    0000070: ac84 c074 06b4 0ecd 10eb f530 e4cd 16cd ...t.......0....
    0000080: 190d 0a4e 6f6e 2d73 7973 7465 6d20 6469 ...Non-system di
    0000090: 736b 0d0a 5072 6573 7320 616e 7920 6b65 sk..Press any ke
    00000a0: 7920 746f 2072 6562 6f6f 740d 0a00 0000 y to reboot.....
    00000b0: 0000 0000 0000 0000 0000 0000 0000 0000 ................
    00000c0: 0000 0000 0000 0000 0000 0000 0000 0000 ................
    00000d0: 0000 0000 0000 0000 0000 0000 0000 0000 ................
    00000e0: 0000 0000 0000 0000 0000 0000 0000 0000 ................
    00000f0: 0000 0000 0000 0000 0000 0000 0000 0000 ................
    0000100: 0000 0000 0000 0000 0000 0000 0000 0000 ................
    0000110: 0000 0000 0000 0000 0000 0000 0000 0000 ................
    0000120: 0000 0000 0000 0000 0000 0000 0000 0000 ................
    0000130: 0000 0000 0000 0000 0000 0000 0000 0000 ................
    0000140: 0000 0000 0000 0000 0000 0000 0000 0000 ................
    0000150: 0000 0000 0000 0000 0000 0000 0000 0000 ................
    0000160: 0000 0000 0000 0000 0000 0000 0000 0000 ................
    0000170: 0000 0000 0000 0000 0000 0000 0000 0000 ................
    0000180: 0000 0000 0000 0000 0000 0000 0000 0000 ................
    0000190: 0000 0000 0000 0000 0000 0000 0000 0000 ................
    00001a0: 0000 0000 0000 0000 0000 0000 0000 0000 ................
    00001b0: 0000 0000 0000 0000 0000 0000 0000 0000 ................
    00001c0: 0000 0000 0000 0000 0000 0000 0000 0000 ................
    00001d0: 0000 0000 0000 0000 0000 0000 0000 0000 ................
    00001e0: 0000 0000 0000 0000 0000 0000 0000 0000 ................
    00001f0: 0000 0000 0000 0000 0000 0000 0000 55aa ..............U.

    GPT 2 @ 409640: VBR contents: None_all_zeros
    0000000: 0000 0000 0000 0000 0000 0000 0000 0000 ................
    0000010: 0000 0000 0000 0000 0000 0000 0000 0000 ................
    0000020: 0000 0000 0000 0000 0000 0000 0000 0000 ................
    0000030: 0000 0000 0000 0000 0000 0000 0000 0000 ................
    0000040: 0000 0000 0000 0000 0000 0000 0000 0000 ................
    0000050: 0000 0000 0000 0000 0000 0000 0000 0000 ................
    0000060: 0000 0000 0000 0000 0000 0000 0000 0000 ................
    0000070: 0000 0000 0000 0000 0000 0000 0000 0000 ................
    0000080: 0000 0000 0000 0000 0000 0000 0000 0000 ................
    0000090: 0000 0000 0000 0000 0000 0000 0000 0000 ................
    00000a0: 0000 0000 0000 0000 0000 0000 0000 0000 ................
    00000b0: 0000 0000 0000 0000 0000 0000 0000 0000 ................
    00000c0: 0000 0000 0000 0000 0000 0000 0000 0000 ................
    00000d0: 0000 0000 0000 0000 0000 0000 0000 0000 ................
    00000e0: 0000 0000 0000 0000 0000 0000 0000 0000 ................
    00000f0: 0000 0000 0000 0000 0000 0000 0000 0000 ................
    0000100: 0000 0000 0000 0000 0000 0000 0000 0000 ................
    0000110: 0000 0000 0000 0000 0000 0000 0000 0000 ................
    0000120: 0000 0000 0000 0000 0000 0000 0000 0000 ................
    0000130: 0000 0000 0000 0000 0000 0000 0000 0000 ................
    0000140: 0000 0000 0000 0000 0000 0000 0000 0000 ................
    0000150: 0000 0000 0000 0000 0000 0000 0000 0000 ................
    0000160: 0000 0000 0000 0000 0000 0000 0000 0000 ................
    0000170: 0000 0000 0000 0000 0000 0000 0000 0000 ................
    0000180: 0000 0000 0000 0000 0000 0000 0000 0000 ................
    0000190: 0000 0000 0000 0000 0000 0000 0000 0000 ................
    00001a0: 0000 0000 0000 0000 0000 0000 0000 0000 ................
    00001b0: 0000 0000 0000 0000 0000 0000 0000 0000 ................
    00001c0: 0000 0000 0000 0000 0000 0000 0000 0000 ................
    00001d0: 0000 0000 0000 0000 0000 0000 0000 0000 ................
    00001e0: 0000 0000 0000 0000 0000 0000 0000 0000 ................
    00001f0: 0000 0000 0000 0000 0000 0000 0000 0000 ................

    GPT 3 @ 126093528: VBR contents: None_all_zeros
    0000000: 0000 0000 0000 0000 0000 0000 0000 0000 ................
    0000010: 0000 0000 0000 0000 0000 0000 0000 0000 ................
    0000020: 0000 0000 0000 0000 0000 0000 0000 0000 ................
    0000030: 0000 0000 0000 0000 0000 0000 0000 0000 ................
    0000040: 0000 0000 0000 0000 0000 0000 0000 0000 ................
    0000050: 0000 0000 0000 0000 0000 0000 0000 0000 ................
    0000060: 0000 0000 0000 0000 0000 0000 0000 0000 ................
    0000070: 0000 0000 0000 0000 0000 0000 0000 0000 ................
    0000080: 0000 0000 0000 0000 0000 0000 0000 0000 ................
    0000090: 0000 0000 0000 0000 0000 0000 0000 0000 ................
    00000a0: 0000 0000 0000 0000 0000 0000 0000 0000 ................
    00000b0: 0000 0000 0000 0000 0000 0000 0000 0000 ................
    00000c0: 0000 0000 0000 0000 0000 0000 0000 0000 ................
    00000d0: 0000 0000 0000 0000 0000 0000 0000 0000 ................
    00000e0: 0000 0000 0000 0000 0000 0000 0000 0000 ................
    00000f0: 0000 0000 0000 0000 0000 0000 0000 0000 ................
    0000100: 0000 0000 0000 0000 0000 0000 0000 0000 ................
    0000110: 0000 0000 0000 0000 0000 0000 0000 0000 ................
    0000120: 0000 0000 0000 0000 0000 0000 0000 0000 ................
    0000130: 0000 0000 0000 0000 0000 0000 0000 0000 ................
    0000140: 0000 0000 0000 0000 0000 0000 0000 0000 ................
    0000150: 0000 0000 0000 0000 0000 0000 0000 0000 ................
    0000160: 0000 0000 0000 0000 0000 0000 0000 0000 ................
    0000170: 0000 0000 0000 0000 0000 0000 0000 0000 ................
    0000180: 0000 0000 0000 0000 0000 0000 0000 0000 ................
    0000190: 0000 0000 0000 0000 0000 0000 0000 0000 ................
    00001a0: 0000 0000 0000 0000 0000 0000 0000 0000 ................
    00001b0: 0000 0000 0000 0000 0000 0000 0000 0000 ................
    00001c0: 0000 0000 0000 0000 0000 0000 0000 0000 ................
    00001d0: 0000 0000 0000 0000 0000 0000 0000 0000 ................
    00001e0: 0000 0000 0000 0000 0000 0000 0000 0000 ................
    00001f0: 0000 0000 0000 0000 0000 0000 0000 0000 ................

    GPT 4 @ 127363072: VBR contents: NTFS_Windows_Vista_BOOTMGR
    0000000: eb52 904e 5446 5320 2020 2000 0208 0000 .R.NTFS .....
    0000010: 0000 0000 00f8 0000 3f00 ff00 0068 9707 ........?....h..
    0000020: 0000 0000 8000 8000 f867 a02e 0000 0000 .........g......
    0000030: 0000 0c00 0000 0000 0200 0000 0000 0000 ................
    0000040: f600 0000 0100 0000 750c 17f8 1e17 f8c6 ........u.......
    0000050: 0000 0000 fa33 c08e d0bc 007c fb68 c007 .....3.....|.h..
    0000060: 1f1e 6866 00cb 8816 0e00 6681 3e03 004e ..hf......f.>..N
    0000070: 5446 5375 15b4 41bb aa55 cd13 720c 81fb TFSu..A..U..r...
    0000080: 55aa 7506 f7c1 0100 7503 e9dd 001e 83ec U.u.....u.......
    0000090: 1868 1a00 b448 8a16 0e00 8bf4 161f cd13 .h...H..........
    00000a0: 9f83 c418 9e58 1f72 e13b 060b 0075 dba3 .....X.r.;...u..
    00000b0: 0f00 c12e 0f00 041e 5a33 dbb9 0020 2bc8 ........Z3... +.
    00000c0: 66ff 0611 0003 160f 008e c2ff 0616 00e8 f...............
    00000d0: 4b00 2bc8 77ef b800 bbcd 1a66 23c0 752d K.+.w......f#.u-
    00000e0: 6681 fb54 4350 4175 2481 f902 0172 1e16 f..TCPAu$....r..
    00000f0: 6807 bb16 6870 0e16 6809 0066 5366 5366 h...hp..h..fSfSf
    0000100: 5516 1616 68b8 0166 610e 07cd 1a33 c0bf U...h..fa....3..
    0000110: 2810 b9d8 0ffc f3aa e95f 0190 9066 601e (........_...f`.
    0000120: 0666 a111 0066 0306 1c00 1e66 6800 0000 .f...f.....fh...
    0000130: 0066 5006 5368 0100 6810 00b4 428a 160e .fP.Sh..h...B...
    0000140: 0016 1f8b f4cd 1366 595b 5a66 5966 591f .......fY[ZfYfY.
    0000150: 0f82 1600 66ff 0611 0003 160f 008e c2ff ....f...........
    0000160: 0e16 0075 bc07 1f66 61c3 a0f8 01e8 0900 ...u...fa.......
    0000170: a0fb 01e8 0300 f4eb fdb4 018b f0ac 3c00 ..............<.
    0000180: 7409 b40e bb07 00cd 10eb f2c3 0d0a 4120 t.............A
    0000190: 6469 736b 2072 6561 6420 6572 726f 7220 disk read error
    00001a0: 6f63 6375 7272 6564 000d 0a42 4f4f 544d occurred...BOOTM
    00001b0: 4752 2069 7320 6d69 7373 696e 6700 0d0a GR is missing...
    00001c0: 424f 4f54 4d47 5220 6973 2063 6f6d 7072 BOOTMGR is compr
    00001d0: 6573 7365 6400 0d0a 5072 6573 7320 4374 essed...Press Ct
    00001e0: 726c 2b41 6c74 2b44 656c 2074 6f20 7265 rl+Alt+Del to re
    00001f0: 7374 6172 740d 0a00 8ca9 bed6 0000 55aa start.........U.

    GPT 5 @ 909627392: VBR contents: Unrecognized (hash=b9e37ba6d83c527c9db101c746533d27)
    0000000: eb63 9000 0000 0000 0000 0000 0000 0000 .c..............
    0000010: 0000 0000 0000 0000 0000 0000 0000 0000 ................
    0000020: 0000 0000 0000 0000 0000 0000 0000 0000 ................
    0000030: 0000 0000 0000 0000 0000 0000 0000 0000 ................
    0000040: 0000 0000 0000 0000 0000 0000 0000 0000 ................
    0000050: 0000 0000 0000 0000 0000 0080 68ac 3d39 ............h.=9
    0000060: 0000 0000 fffa 9090 f6c2 8074 05f6 c270 ...........t...p
    0000070: 7402 b280 ea79 7c00 0031 c08e d88e d0bc t....y|..1......
    0000080: 0020 fba0 647c 3cff 7402 88c2 52bb 1704 . ..d|<.t...R...
    0000090: 8027 0374 06be 887d e817 01be 057c b441 .'.t...}.....|.A
    00000a0: bbaa 55cd 135a 5272 3d81 fb55 aa75 3783 ..U..ZRr=..U.u7.
    00000b0: e101 7432 31c0 8944 0440 8844 ff89 4402 ..t21..D.@.D..D.
    00000c0: c704 1000 668b 1e5c 7c66 895c 0866 8b1e ....f..\|f.\.f..
    00000d0: 607c 6689 5c0c c744 0600 70b4 42cd 1372 `|f.\..D..p.B..r
    00000e0: 05bb 0070 eb76 b408 cd13 730d f6c2 800f ...p.v....s.....
    00000f0: 84d0 00be 937d e982 0066 0fb6 c688 64ff .....}...f....d.
    0000100: 4066 8944 040f b6d1 c1e2 0288 e888 f440 @f.D...........@
    0000110: 8944 080f b6c2 c0e8 0266 8904 66a1 607c .D.......f..f.`|
    0000120: 6609 c075 4e66 a15c 7c66 31d2 66f7 3488 f..uNf.\|f1.f.4.
    0000130: d131 d266 f774 043b 4408 7d37 fec1 88c5 .1.f.t.;D.}7....
    0000140: 30c0 c1e8 0208 c188 d05a 88c6 bb00 708e 0........Z....p.
    0000150: c331 dbb8 0102 cd13 721e 8cc3 601e b900 .1......r...`...
    0000160: 018e db31 f6bf 0080 8ec6 fcf3 a51f 61ff ...1..........a.
    0000170: 265a 7cbe 8e7d eb03 be9d 7de8 3400 bea2 &Z|..}....}.4...
    0000180: 7de8 2e00 cd18 ebfe 4752 5542 2000 4765 }.......GRUB .Ge
    0000190: 6f6d 0048 6172 6420 4469 736b 0052 6561 om.Hard Disk.Rea
    00001a0: 6400 2045 7272 6f72 0d0a 00bb 0100 b40e d. Error........
    00001b0: cd10 ac3c 0075 f4c3 0000 0000 0000 0000 ...<.u..........
    00001c0: 0000 0000 0000 0000 0000 0000 0000 0000 ................
    00001d0: 0000 0000 0000 0000 0000 0000 0000 0000 ................
    00001e0: 0000 0000 0000 0000 0000 0000 0000 0000 ................
    00001f0: 0000 0000 0000 0000 0000 0000 0000 55aa ..............U.

    GPT 6 @ 974675968: VBR contents: None_all_zeros
    0000000: 0000 0000 0000 0000 0000 0000 0000 0000 ................
    0000010: 0000 0000 0000 0000 0000 0000 0000 0000 ................
    0000020: 0000 0000 0000 0000 0000 0000 0000 0000 ................
    0000030: 0000 0000 0000 0000 0000 0000 0000 0000 ................
    0000040: 0000 0000 0000 0000 0000 0000 0000 0000 ................
    0000050: 0000 0000 0000 0000 0000 0000 0000 0000 ................
    0000060: 0000 0000 0000 0000 0000 0000 0000 0000 ................
    0000070: 0000 0000 0000 0000 0000 0000 0000 0000 ................
    0000080: 0000 0000 0000 0000 0000 0000 0000 0000 ................
    0000090: 0000 0000 0000 0000 0000 0000 0000 0000 ................
    00000a0: 0000 0000 0000 0000 0000 0000 0000 0000 ................
    00000b0: 0000 0000 0000 0000 0000 0000 0000 0000 ................
    00000c0: 0000 0000 0000 0000 0000 0000 0000 0000 ................
    00000d0: 0000 0000 0000 0000 0000 0000 0000 0000 ................
    00000e0: 0000 0000 0000 0000 0000 0000 0000 0000 ................
    00000f0: 0000 0000 0000 0000 0000 0000 0000 0000 ................
    0000100: 0000 0000 0000 0000 0000 0000 0000 0000 ................
    0000110: 0000 0000 0000 0000 0000 0000 0000 0000 ................
    0000120: 0000 0000 0000 0000 0000 0000 0000 0000 ................
    0000130: 0000 0000 0000 0000 0000 0000 0000 0000 ................
    0000140: 0000 0000 0000 0000 0000 0000 0000 0000 ................
    0000150: 0000 0000 0000 0000 0000 0000 0000 0000 ................
    0000160: 0000 0000 0000 0000 0000 0000 0000 0000 ................
    0000170: 0000 0000 0000 0000 0000 0000 0000 0000 ................
    0000180: 0000 0000 0000 0000 0000 0000 0000 0000 ................
    0000190: 0000 0000 0000 0000 0000 0000 0000 0000 ................
    00001a0: 0000 0000 0000 0000 0000 0000 0000 0000 ................
    00001b0: 0000 0000 0000 0000 0000 0000 0000 0000 ................
    00001c0: 0000 0000 0000 0000 0000 0000 0000 0000 ................
    00001d0: 0000 0000 0000 0000 0000 0000 0000 0000 ................
    00001e0: 0000 0000 0000 0000 0000 0000 0000 0000 ................
    00001f0: 0000 0000 0000 0000 0000 0000 0000 0000 ................
    ===============================================================================
    /dev/disk1
    #: TYPE NAME SIZE IDENTIFIER
    0: VAULT *1.1 GB disk1
    ---------------------------------------------
    Device Identifier: disk1
    Device Node: /dev/disk1
    Part of Whole: disk1
    Device / Media Name: Apple read/write Media

    Volume Name: VAULT
    Escaped with Unicode: VAULT

    Mounted: Yes
    Mount Point: /Volumes/VAULT
    Escaped with Unicode: /Volumes/VAULT

    File System Personality: MS-DOS FAT32
    Type (Bundle): msdos
    Name (User Visible): MS-DOS (FAT32)

    Content (IOContent): None
    OS Can Be Installed: No
    Media Type: Generic
    Protocol: Disk Image
    SMART Status: Not Supported

    Total Size: 1.1 GB (1073479680 Bytes) (exactly 2096640 512-Byte-Blocks)
    Volume Free Space: 1.1 GB (1067761664 Bytes) (exactly 2085472 512-Byte-Blocks)
    Device Block Size: 512 Bytes

    Read-Only Media: No
    Read-Only Volume: No
    Ejectable: Yes

    Whole: Yes
    Internal: No
    OS 9 Drivers: No
    Low Level Format: Not supported

    0 @ 0: VBR contents: Unrecognized (hash=d41d8cd98f00b204e9800998ecf8427e)

    EFI found at IODeviceTree:/efi
    Current EFI boot device string is: '<array><dict><key>IOMatch</key><dict><key>IOProviderClass</key><string>IOMedia</string><key>IOPropertyMatch</key><dict><key>UUID</key><string>462B8094-8A52-4B95-B1DC-7200F0D1B783</string></dict></dict><key>BLLastBSDName</key><string>disk0s2</string></dict></array>'
    Boot option is 8BE4DF61-93CA-11D2-AA0D-00E098032B8C:Boot0080
    Processing boot option 'Mac OS X'
    Boot option matches XML representation
    Found device: disk0s2
    Disk boot device detected
    /dev/disk0s2
    ===============================================================================
    EFI found at IODeviceTree:/efi
    Current EFI boot device string is: '<array><dict><key>IOMatch</key><dict><key>IOProviderClass</key><string>IOMedia</string><key>IOPropertyMatch</key><dict><key>UUID</key><string>462B8094-8A52-4B95-B1DC-7200F0D1B783</string></dict></dict><key>BLLastBSDName</key><string>disk0s2</string></dict></array>'
    Boot option is 8BE4DF61-93CA-11D2-AA0D-00E098032B8C:Boot0080
    Processing boot option 'Mac OS X'
    Boot option matches XML representation
    Found device: disk0s2
    Disk boot device detected
    mount: /
    Mount point for / is /
    Boot blocks read successfully
    GPT detected
    No auxiliary booter partition required
    System partition found
    Returning booter information dictionary:
    <CFBasicHash 0x7f9bfa300410 [0x7fff7dbeeea0]>{type = mutable dict, count = 3,
    entries =>
    0 : <CFString 0x109be8fb0 [0x7fff7dbeeea0]>{contents = "System Partitions"} = (
    disk0s1
    )
    1 : <CFString 0x109be8f70 [0x7fff7dbeeea0]>{contents = "Data Partitions"} = (
    disk0s2
    )
    2 : <CFString 0x109be8f50 [0x7fff7dbeeea0]>{contents = "Auxiliary Partitions"} = (
    )
    }

    finderinfo[0]: 116 => Blessed System Folder is /System/Library/CoreServices
    finderinfo[1]: 280701 => Blessed System File is /System/Library/CoreServices/boot.efi
    finderinfo[2]: 0 => Open-folder linked list empty
    finderinfo[3]: 0 => No alternate OS blessed file/folder
    finderinfo[4]: 0 => Unused field unset
    finderinfo[5]: 116 => OS X blessed folder is /System/Library/CoreServices
    64-bit VSDB volume id: 0x6BC2248DCDBBBD1F
    ===============================================================================
    Hitachi HTS725050A9A362 Media <class IOMedia>
    {
    "Removable" = No
    "Content" = "GUID_partition_scheme"
    "Whole" = Yes
    "Leaf" = No
    "BSD Name" = "disk0"
    "Ejectable" = No
    "Preferred Block Size" = 512
    "IOMediaIcon" = {"IOBundleResourceFile"="Internal.icns","CFBundleIdentifier"="com.apple.iokit.IOStorageFamily"}
    "BSD Minor" = 0
    "IOGeneralInterest" = "IOCommand is not serializable"
    "Writable" = Yes
    "BSD Major" = 14
    "Size" = 500107862016
    "IOBusyInterest" = "IOCommand is not serializable"
    "Open" = Yes
    "Content Hint" = ""
    "BSD Unit" = 0
    }
    EFI System Partition@1 <class IOMedia>
    {
    "Removable" = No
    "Content" = "C12A7328-F81F-11D2-BA4B-00A0C93EC93B"
    "Whole" = No
    "Leaf" = Yes
    "BSD Name" = "disk0s1"
    "Ejectable" = No
    "Preferred Block Size" = 512
    "BSD Minor" = 1
    "IOGeneralInterest" = "IOCommand is not serializable"
    "Writable" = Yes
    "UUID" = "3E7D4DE4-59C2-461E-9C86-802926A11C58"
    "Partition ID" = 1
    "BSD Major" = 14
    "Size" = 209715200
    "IOBusyInterest" = "IOCommand is not serializable"
    "Open" = No
    "Content Hint" = "C12A7328-F81F-11D2-BA4B-00A0C93EC93B"
    "BSD Unit" = 0
    }
    Mac OS X@2 <class IOMedia>
    {
    "Removable" = No
    "Content" = "48465300-0000-11AA-AA11-00306543ECAC"
    "Whole" = No
    "Leaf" = Yes
    "BSD Name" = "disk0s2"
    "Ejectable" = No
    "Preferred Block Size" = 512
    "BSD Minor" = 2
    "IOGeneralInterest" = "IOCommand is not serializable"
    "Writable" = Yes
    "UUID" = "462B8094-8A52-4B95-B1DC-7200F0D1B783"
    "Partition ID" = 2
    "BSD Major" = 14
    "Size" = 64350150656
    "IOBusyInterest" = "IOCommand is not serializable"
    "Open" = Yes
    "Content Hint" = "48465300-0000-11AA-AA11-00306543ECAC"
    "BSD Unit" = 0
    }
    Recovery HD@3 <class IOMedia>
    {
    "Removable" = No
    "Content" = "426F6F74-0000-11AA-AA11-00306543ECAC"
    "Whole" = No
    "Leaf" = Yes
    "BSD Name" = "disk0s3"
    "Ejectable" = No
    "Preferred Block Size" = 512
    "BSD Minor" = 3
    "IOGeneralInterest" = "IOCommand is not serializable"
    "Writable" = Yes
    "UUID" = "3C7F593C-BF7F-4BDA-B252-95F5525C8D57"
    "Partition ID" = 3
    "BSD Major" = 14
    "Size" = 650006528
    "IOBusyInterest" = "IOCommand is not serializable"
    "Open" = No
    "Content Hint" = "426F6F74-0000-11AA-AA11-00306543ECAC"
    "BSD Unit" = 0
    }
    BOOTCAMP@4 <class IOMedia>
    {
    "Removable" = No
    "Content" = "EBD0A0A2-B9E5-4433-87C0-68B6B72699C7"
    "Whole" = No
    "Leaf" = Yes
    "BSD Name" = "disk0s4"
    "Ejectable" = No
    "Preferred Block Size" = 512
    "BSD Minor" = 4
    "IOGeneralInterest" = "IOCommand is not serializable"
    "Writable" = Yes
    "UUID" = "6EA7680D-B662-4EF0-B0A3-D72421F24427"
    "Partition ID" = 4
    "BSD Major" = 14
    "Size" = 400519331840
    "IOBusyInterest" = "IOCommand is not serializable"
    "Open" = Yes
    "Content Hint" = "EBD0A0A2-B9E5-4433-87C0-68B6B72699C7"
    "BSD Unit" = 0
    }
    Untitled 5@5 <class IOMedia>
    {
    "Removable" = No
    "Content" = "EBD0A0A2-B9E5-4433-87C0-68B6B72699C7"
    "Whole" = No
    "Leaf" = Yes
    "BSD Name" = "disk0s5"
    "Ejectable" = No
    "Preferred Block Size" = 512
    "BSD Minor" = 5
    "IOGeneralInterest" = "IOCommand is not serializable"
    "Writable" = Yes
    "UUID" = "1ACB709D-F2BA-4C1A-9F08-7159023E96C2"
    "Partition ID" = 5
    "BSD Major" = 14
    "Size" = 33304870912
    "IOBusyInterest" = "IOCommand is not serializable"
    "Open" = No
    "Content Hint" = "EBD0A0A2-B9E5-4433-87C0-68B6B72699C7"
    "BSD Unit" = 0
    }
    Untitled 6@6 <class IOMedia>
    {
    "Removable" = No
    "Content" = "0657FD6D-A4AB-43C4-84E5-0933C84B4F4F"
    "Whole" = No
    "Leaf" = Yes
    "BSD Name" = "disk0s6"
    "Ejectable" = No
    "Preferred Block Size" = 512
    "BSD Minor" = 6
    "IOGeneralInterest" = "IOCommand is not serializable"
    "Writable" = Yes
    "UUID" = "DBA71245-E569-4096-8813-6DD12FCB332B"
    "Partition ID" = 6
    "BSD Major" = 14
    "Size" = 1073741824
    "IOBusyInterest" = "IOCommand is not serializable"
    "Open" = No
    "Content Hint" = "0657FD6D-A4AB-43C4-84E5-0933C84B4F4F"
    "BSD Unit" = 0
    }
    Apple read/write Media <class IOMedia>
    {
    "Removable" = Yes
    "Content" = ""
    "Whole" = Yes
    "Leaf" = Yes
    "BSD Name" = "disk1"
    "Ejectable" = Yes
    "Preferred Block Size" = 512
    "IOMediaIcon" = {"IOBundleResourceFile"="Removable.icns","CFBundleIdentifier"="com.apple.iokit.IOStorageFamily"}
    "BSD Minor" = 7
    "IOGeneralInterest" = "IOCommand is not serializable"
    "Writable" = Yes
    "BSD Major" = 14
    "Size" = 1073479680
    "IOBusyInterest" = "IOCommand is not serializable"
    "Open" = Yes
    "Content Hint" = ""
    "BSD Unit" = 1
    }
    ===============================================================================
    "fmm-computer-name" = <"Kal Jade’s MacBook Pro">
    "boot-image" = <02010c00d041030a0000000001010600021f03120a000000000000000404180032003800300064003000320030003000300000007fff0400>
    "SystemAudioVolume" = <5b>
    "gpu-policy" = <01>
    "BootCampHD" = <02010c00d041030a0000000001010600021f03120a000000000000007fff0400>
    "efi-apple-payload1" = <"<array><dict><key>IOMatch</key><dict><key>IOProviderClass</key><string>IOMedia</string><key>IOPropertyMatch</key><dict><key>UUID</key><string>3E7D4DE4-59C2-461E-9C86-802926A11C58</string></dict></dict><key>BLLastBSDName</key><string>disk0s1</string></dict><dict><key>IOEFIDevicePathType</key><string>MediaFilePath</string><key>Path</key><string>\EFI\APPLE\FIRMWARE\HPM-em-00020007.bin</string></dict></array>">
    "prev-lang:kbd" = <"English:15">
    "EFICapsule_Result" = <"STAR">
    "efi-apple-recovery" = <"<array><dict><key>IOMatch</key><dict><key>IOProviderClass</key><string>IOMedia</string><key>IOPropertyMatch</key><dict><key>UUID</key><string>3E7D4DE4-59C2-461E-9C86-802926A11C58</string></dict></dict><key>BLLastBSDName</key><string>disk0s1</string></dict><dict><key>IOEFIDevicePathType</key><string>MediaFilePath</string><key>Path</key><string>\EFI\APPLE\FIRMWARE\MBP81_0047_0EB_LOCKED.scap</string></dict></array>">
    "efi-apple-payload0-data" = <02010c00d041030a0000000001010600021f03120a0000000000000004012a000100000028000000000000000040060000000000e44d7d3ec2591e469c86802926a11c580202040448005c004500460049005c004100500050004c0045005c004600490052004d0057004100520045005c004d00420050002d00320032002d00300031002e00620069006e0000007fff0400>
    "ThorUpdateResult" = <000005020003000000000000000000000000000000000000>
    "tbt-options" = <00>
    "aht-results" = <"<dict><key>_name</key><string>spdiags_aht_value</string><key>spdiags_last_run_key</key><date>4011-07-10T07:02:47Z</date><key>spdiags_result_key</key><string>spdiags_passed_value</string><key>spdiags_version_key</key><string>3A209</string></dict>">
    "efi-apple-payload0" = <"<array><dict><key>IOMatch</key><dict><key>IOProviderClass</key><string>IOMedia</string><key>IOPropertyMatch</key><dict><key>UUID</key><string>3E7D4DE4-59C2-461E-9C86-802926A11C58</string></dict></dict><key>BLLastBSDName</key><string>disk0s1</string></dict><dict><key>IOEFIDevicePathType</key><string>MediaFilePath</string><key>Path</key><string>\EFI\APPLE\FIRMWARE\MBP-22-01.bin</string></dict></array>">
    "efi-boot-device-data" = <02010c00d041030a0000000001010600021f03120a0000000000000004012a00020000002840060000000000b0c87d070000000094802b46528a954bb1dc7200f0d1b78302027fff0400>
    "efi-boot-device" = "<array><dict><key>IOMatch</key><dict><key>IOProviderClass</key><string>IOMedia</string><key>IOPropertyMatch</key><dict><key>UUID</key><string>462B8094-8A52-4B95-B1DC-7200F0D1B783</string></dict></dict><key>BLLastBSDName</key><string>disk0s2</string></dict></array>"
    "efi-apple-payload1-data" = <02010c00d041030a0000000001010600021f03120a0000000000000004012a000100000028000000000000000040060000000000e44d7d3ec2591e469c86802926a11c580202040454005c004500460049005c004100500050004c0045005c004600490052004d0057004100520045005c00480050004d002d0065006d002d00300030003000320030003000300037002e00620069006e0000007fff0400>
    ===============================================================================
    CHEETA-Mac:desktop kal$

    My EasyBCD settings are:

    There are a total of 2 entries listed in the bootloader.

    Default: Windows 7 Ultimate
    Timeout: 3 seconds
    EasyBCD Boot Device: C:\

    Entry #1
    Name: Windows 7 Ultimate
    BCD ID: {current}
    Drive: C:\ Bootloader Path: \Windows\system32\winload.exe

    Entry #2
    Name: Ubuntu Linux
    BCD ID: {039b57f4-5d44-11e0-8026-b38cb5d961b9}
    Drive: C:\ Bootloader Path: \NST\AutoNeoGrub0.mbr

    My rEFIt options are:

    Boot Mac OS X from Mac OS X
    Boot Windows from Partition 4
    Boot Linux from HD

    The weird thing is that now if I select Linux instead of "Missing Operation System" I get the same boot loader as when I select Windows, it's like rEFIt isn't seeing Partition 5 - which is where Ubuntu is installed (and where I installed Grub2).

    If I run the rEFIt partition tool it says my partitions are already synchronised (but GPT shows my Linux Partitions while MBR doesn't).

    As you have probably already guessed manipulating the rEFIt source code is currently beyond my skill set, so that's not really an option right now.

    I haven't tried renaming com.apple.recovery.boot to EFI yet as the Linux problem is a higher priority for me than the Recovery HD (plus I don't want to render it unusable in case I need it during the fixing Linux process).

    Thanks again for your time, it's greatly appreciated to find someone with the skills to help who is willing to share their time!

    Regards,

    Kal

     
  • Joe van Tunen
    Joe van Tunen
    2011-08-02

    rEFIt sees the Linux partition in the GPT but your version of Linux can't boot from EFI or EFI is not well supported.

    rEFIt needs to to see the Linux partition in the MBR so that it will use BIOS to boot it. rEFIt sets the boot flag in the MBR for the selected partition, then calls BIOS. BIOS executes the boot code in the MBR which loads the boot code from the first block of the partition that has the boot flag set. The boot code runs GRUB2 for Linux or BOOTMGR for Windows.

    Since you have more than 3 partitions, you should not use rEFIt's synchronization tool because it does not allow you to pick which GPT partitions should be in the MBR.

    You can edit the MBR manually using "sudo fdisk -e /dev/disk0", or use iPartition, or use gdisk.
    http://www.coriolis-systems.com/iPartition.php
    https://sourceforge.net/projects/gptfdisk/
    http://www.rodsbooks.com/gdisk/

    Your MBR should look something like this:

    1: EE 1023 254 63 - 1023 254 63 [ 1 409639] <Unknown ID>
    2: AF 1023 254 63 - 1023 254 63 [ 409640 125683888] HFS+
    3: 83 1023 254 63 - 1023 254 63 [ 909627392 65048576] Linux files*
    *4: 07 1023 254 63 - 1023 254 63 [ 127363072 782264320] HPFS/QNX/AUX

    - You could sort that by start block but it's not necessary.
    - You may need to change the Linux partition's ID from 83 to 07 if you want it to be visible in Windows with some third party extfs file system drivers.
    - The HFS partition doesn't need to be in the MBR unless you want it to be visible in Windows. If you don't, then the EFI protective partition should have a size of 127363071 to cover the Mac partition and the Recovery HD partition.

    You could probably create your own Recovery HD partition, and use Disk Utility to Restore from the original Recovery HD partition to the new Recovery HD partition. You would need to shrink the Mac OS X partition by 650 MB to make room for the new partition. Then do some experimenting.

    The following commands will add more options to Disk Utility. One of the options (the debug menu) will let you the Recover HD partition.
    defaults write com.apple.DiskUtility advanced-image-options -bool true
    defaults write com.apple.DiskUtility DUDebugMenuEnabled -bool true

     
  • Kalsta
    Kalsta
    2011-08-03

    Joe, you are a genius!

    Using "sudo fdisk -e /dev/disk0", I edited the MBR and now I can natively boot into Lion, Windows, and Linux!!

    You were right it was rEFIt synchronization I opened it after I had tested all OS's working and it suggested changing them back to the way they were before (which I of course declined).

    I have decided not to worry about the Recovery HD as if I ever need it, I can always just hold down the option key and that will be the least of my worries at that time, and other than that there's no real need to see it.

    I thank you again for your time & assistance, this was really starting to annoy me as I use all three OS's regularly, and now I can access them using my custom rEFIt bootloader.

    Cheers,

    Kal